// CMemPatch
// http://forlix.org/, df@forlix.org
//
// Copyright (c) 2010-2011 Dominik Friedrichs

#ifndef CMEMPATCH_H
#define CMEMPATCH_H

#include <stdio.h>
#include <windows.h>

class CMemPatch
{
public:
  bool PatchMemory(const char *Patch,
                   void *Address, ...);
  bool RestoreMemory(void);

  CMemPatch(void);
  ~CMemPatch(void);

private:
  void FreePatchMemory(void);
  static bool MemReadRaw(const void *readaddr,
                         void *buffer,
                         size_t length);
  static bool MemWriteRaw(void *writeaddr,
                          const void *buffer,
                          size_t length);
  static int HexPatchToBinary(const char *str,
                              unsigned char *&data,
                              void *baseaddr, va_list ap);
  static bool IsHexChar(char c);

  unsigned char *PatchAddress;

  unsigned char *PatchData;
  unsigned int PatchLength;

  unsigned char *MemoryBackup;
  bool MemoryPatched;
};

#endif // CMEMPATCH_H
