// CSigScan
// http://forlix.org/, df@forlix.org
//
// Copyright (c) 2010-2014 Dominik Friedrichs

#ifndef CSIGSCAN_H
#define CSIGSCAN_H

#include <stdio.h>
#include <windows.h>

class CSigScan
{
public:
  bool FindSignature(void);
  void *GetSigAddress(int Offset=0);

  CSigScan(const char *Signature,
           const char *Module);
  ~CSigScan(void);

private:
  bool SetSignature(const char *str_hexsig);
  bool SetModule(const char *str_module);
  void FreeSignatureMemory(void);
  static int HexSigToBinary(const char *str,
                            unsigned char *&data,
                            unsigned char *&mask);
  static bool IsHexChar(char c);

  unsigned char *SigAddress;

  unsigned char *SigData;
  unsigned char *SigMask;

  unsigned long SigLength;

  const unsigned char *MemoryBase;
  unsigned long MemoryLength;
};

#endif // CSIGSCAN_H
